#include <zombie_escape>

#define PLUGIN "[ZE] Extra Item : Leap"
#define VERSION "1.5.7"
#define AUTHOR "Fry!"

/*================================================================================
 [Plugin Customization]
=================================================================================*/

new bool:g_hasLongJump[33]
new Float:g_last_LongJump_time[33]
new g_iItemID, g_LongJump_cost, g_LongJump_force, g_LongJump_height, g_LongJump_cooldown , g_iLimit[33]  ,  cvar_limit

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_cvar("zp_extra_leap",VERSION,FCVAR_SERVER|FCVAR_EXTDLL|FCVAR_UNLOGGED|FCVAR_SPONLY)
	g_iItemID = ze_register_item("Leap", 20, 0)
	
	g_LongJump_force = register_cvar("ze_longjump_force", "580")
	g_LongJump_height = register_cvar("ze_longjump_height", "320")
	g_LongJump_cooldown = register_cvar("ze_longjump_cooldown", "10.0")
	g_LongJump_cost = register_cvar("ze_longjump_cost", "20")
	cvar_limit = register_cvar("ze_longjump_limit", "2")
	
	register_clcmd("say /blj", "buy_longjump")
	
	register_forward(FM_PlayerPreThink, "fw_PlayerPreThink")
	
	register_event("DeathMsg", "death", "a")
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0")
}

// Reset on disconnection
public client_disconnected(id)
{
	g_hasLongJump[id] = false
}

// Reset on death
public death()
{
	g_hasLongJump[read_data(2)] = false
}

// Reset if turned into human
public ze_user_humanized(id)
{
	g_hasLongJump[id] = false
}

// Reset at round start (for everyone)
public event_round_start()
{
	for (new i = 1; i <= 32; i++)
		g_hasLongJump[i] = false
}

// Buy throught extra items menu
public  ze_select_item_pre(id, itemid)
{
    // Return Available and we will block it in Post, So it dosen't affect other plugins
    if (itemid != g_iItemID)
        return ZE_ITEM_AVAILABLE
   
    // Available for Zombies only, So don't show it for Humans
    if (!ze_is_user_zombie(id))
        return ZE_ITEM_DONT_SHOW  
   
    // If he bought it more than 3 so return that it's not Available
    if (g_iLimit[id] >= get_pcvar_num(cvar_limit))
        return ZE_ITEM_UNAVAILABLE
   
    return ZE_ITEM_AVAILABLE
} 
 
public  ze_select_item_post(id, itemid) 
{
    // This is not our item, Block it here and don't execute the blew code
    if (itemid != g_iItemID)
        return
	  
    buy_longjump(id) 
    g_iLimit[id]++ // Mean g_iLimit[id] = g_iLimit[id] + 1
}     

// Buy through command "say /blj"
public  buy_longjump(id)
{
	if ( g_hasLongJump[id] )
	{
		client_print(id, print_chat, "[ZE] You have already purchased a jumppack.")
		return PLUGIN_HANDLED
	}
	
	if ( !is_user_alive(id) )
	{
		client_print(id, print_chat, "[ZE] You can't buy jumppack because You are dead.")
		return PLUGIN_HANDLED
	} 
	
	new money = ze_get_escape_coins(id) 
	new cost = get_pcvar_num(g_LongJump_cost)
	
	if ( money < cost )
	{
		client_print(id, print_chat, "[ZE] You don't have enough ammo packs to buy a jumppack. (%i needed).", cost ) 
		return PLUGIN_HANDLED
	}
	
	g_hasLongJump[id] = true
	
	ze_set_escape_coins(id, money) 
	
	client_print(id, print_chat, "[ZE] You have bought a Jump Pack. To use it, press duck and jump while moving forward.")
	
	return PLUGIN_HANDLED
}

	
public fw_PlayerPreThink(id)
{
	if (!is_user_alive(id))
		return FMRES_IGNORED
	
	if (allow_LongJump(id))
	{
		static Float:velocity[3]
		velocity_by_aim(id, get_pcvar_num(g_LongJump_force), velocity)
		
		velocity[2] = get_pcvar_float(g_LongJump_height)
		
		set_pev(id, pev_velocity, velocity)
		
		g_last_LongJump_time[id] = get_gametime()
	}
	
	return FMRES_IGNORED
}

// Check if the player can longjump
allow_LongJump(id)
{
	if (!g_hasLongJump[id])
		return false
	
	if (!(pev(id, pev_flags) & FL_ONGROUND) || fm_get_speed(id) < 80)
		return false
	
	static buttons
	buttons = pev(id, pev_button)
	
	if (!is_user_bot(id) && (!(buttons & IN_JUMP) || !(buttons & IN_DUCK)))
		return false
	
	if (get_gametime() - g_last_LongJump_time[id] < get_pcvar_float(g_LongJump_cooldown))
		return false
	
	return true
}

// Get entity's speed (from fakemeta_util)
stock fm_get_speed(entity)
{
	static Float:velocity[3]
	pev(entity, pev_velocity, velocity)
	
	return floatround(vector_length(velocity))
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1049\\ f0\\ fs16 \n\\ par }
*/
